﻿package 
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.ColorTransform;
	import flash.geom.Point;
	import flash.events.MouseEvent;
	import flash.sampler.NewObjectSample;
	import flash.geom.Rectangle;

	public class Coliner extends Sprite
	{
		private var angle:Number = 0;
		private var path:Array;
		private var pathHeight:Number;
		private var image:BitmapData;
		private var rect:Rectangle = new Rectangle(0, 0, 600, 600);
		private var c_trs:ColorTransform = new ColorTransform(.99,.99,1,1);
		private var support:Sprite = new Sprite();
		public function Coliner()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
			addEventListener(MouseEvent.MOUSE_DOWN, mouseHandler);
		}
		private function addedHandler(e:Event):void
		{
			addChild(new Bitmap (image = new BitmapData(stage.stageWidth, stage.stageHeight,false,0x000000)));
			this.addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		private function mouseHandler(e:MouseEvent):void{
			trace("CLICK");
			image.fillRect(rect, 0x000000);
			
		}
		private function enterHandler(e:Event):void
		{
			support.graphics.clear();
			support.graphics.moveTo(0,stage.stageHeight-200);
			var mX:Number = stage.stageWidth / 2 - mouseX;
			var color:Number = Math.random() * 0xff0000;
			for (var i:Number=0; i<stage.stageWidth; i++)
			{
				
				var posy:Number = Math.sin((i+angle/10)*Math.PI/180)*Math.cos(i*Math.PI/180)*(stage.stageWidth/2-i)*(mX/100);
				support.graphics.lineStyle(.1,Math.random()*0x00ff00);
				support.graphics.lineTo(i*1,stage.stageHeight-200+posy);
			}
			angle +=  1;

			image.colorTransform(image.rect, c_trs);
			image.scroll(-0.1 * (mouseX/10), -1.5 * (mouseY/100));
			image.draw(support);
		}
	}
}